## spml-g95 0.5.0

=== doc/Makefile ===
# Makefile for spmodel library document
#
# Version:: $Id: Makefile,v 1.20 2009-02-28 19:55:43 uwabami Exp $
#
# include ../Config.mk

LATEX=platex
DVIPDFM=dvipdfmx
MKDIR=mkdir
INSTALL=cp
CPP=cpp
HTMLDIR=../html

RDOC=/usr/bin/rdoc1.8
#RDOC=/var/lib/gems/1.8/bin/rdoc-f95
RDOCOPT=--ignore-case --charset euc-jp  \
	--inline-source --op html/ \
	--title "SPML References Manual" -U 
RDOCLIB=/GFD_Dennou_Club/ftp/arch/dcmodel/lib/ruby/1.8

F90FILES=src/*.f90 src-mpi/*.f90 doc/*.rdoc
MAINPAGE=doc/spml_modules.rdoc

PDF=chebyshev.pdf cheb_gal.pdf chebyshev_origin.pdf \
	w_module.pdf spectral_radial.pdf
HTML=INSTALL.html INSTALL.html.ja

all: $(PDF) html
html:
	make -f ./Makefile.rd2html

install: all
	cd ../src/ ; $(CPP) -P -D LAPACK eigmatrix.g90 > eigmatrix.f90
	cd .. ; RUBYLIB=$(RDOCLIB) $(RDOC) $(RDOCOPT) \
			--main $(MAINPAGE) $(F90FILES)
	rm ../src/eigmatrix.f90
	$(INSTALL) $(PDF) $(HTMLDIR)/
	$(INSTALL) $(HTML) $(HTMLDIR)/

clean:
	-rm -f *.pdf

clean.all: clean
	-make -f Makefile.rd2html clean
	-rm -rf $(HTMLDIR) INSTALL.html INSTALL.html.ja

distclean: clean.all
.SUFFIXES: .tex .pdf
.tex.pdf:
	$(LATEX) $<
	$(LATEX) $<
	$(LATEX) $<
	$(LATEX) $<
	$(DVIPDFM) $*.dvi 
	rm -f *.bak *.dvi *.aux *.log *~

=== spmfrt/Makefile ===
# Makefile for spmfrt

include ../Config.mk

TARGET=spm

ifeq (X$(MPIFC),X)
	ALLTARGET=$(TARGET)frt $(TARGET)config
else
	ALLTARGET=$(TARGET)frt $(TARGET)config mpi$(TARGET)frt
endif

all: $(ALLTARGET)

install: $(TARGET)frt
	test -d $(DEST_BIN) || install -d $(DEST_BIN)
	cp $(TARGET)frt $(DEST_BIN)
	cp $(TARGET)config $(DEST_BIN)
	if [ X$(MPIFC) != X ]; then \
		cp mpi$(TARGET)frt $(DEST_BIN) ;\
	fi

$(TARGET)frt: $(TARGET)frtgen.sh Makefile ../Config.mk
	@echo "Making shell script $(TARGET)frt"
	LIBNAME=$(LIBNAME) MODINSTDIR=$(DEST_INC) \
		LIBINSTDIR=$(DEST_LIB) \
		SYSLDFLAGS="$(SYSLDFLAGS)" \
		SYSLDLIBS="$(SYSLDLIBS)" \
		SYSFFLAGS="$(SYSFFLAGS)" \
		F90MODTYPE=$(F90MODTYPE) FC=$(FC) \
		sh ./$(TARGET)frtgen.sh $@
	chmod +x $(TARGET)frt

$(TARGET)config: $(TARGET)configgen.sh Makefile ../Config.mk
	@echo "Making shell script $(TARGET)config"
	LIBNAME=$(LIBNAME) MODINSTDIR=$(DEST_INC) \
		LIBINSTDIR=$(DEST_LIB) \
		SYSLDFLAGS="$(SYSLDFLAGS)" \
		SYSLDLIBS="$(SYSLDLIBS)" \
		SYSFFLAGS="$(SYSFFLAGS)" \
		F90MODTYPE=$(F90MODTYPE) FC=$(FC) \
		sh ./$(TARGET)configgen.sh $@
	chmod +x $(TARGET)config

mpi$(TARGET)frt: $(TARGET)frtgen.sh Makefile ../Config.mk
	@echo "Making shell script mpi$(TARGET)frt"
	LIBNAME=$(LIBNAME) MODINSTDIR=$(DEST_INC) \
		LIBINSTDIR=$(DEST_LIB) \
		SYSLDFLAGS="$(SYSLDFLAGS)" \
		SYSLDLIBS="$(SYSLDLIBS)" \
		SYSFFLAGS="$(SYSFFLAGS)" \
		F90MODTYPE=$(F90MODTYPE) FC=$(MPIFC) \
		sh ./$(TARGET)frtgen.sh $@
	chmod +x mpi$(TARGET)frt

clean:
	-rm -f *~ $(TARGET)frt $(TARGET)config mpi$(TARGET)frt

=== src-mpi/Makefile ===
# Makefile for spmpdel library

include ../Config.mk

TARGET=../src/lib$(LIBNAME).a

all: $(TARGET)

install: $(TARGET)
	test -d $(DEST_INC) || install -d $(DEST_INC)
	install -m 644 $(MODS) $(MODINCS) $(DEST_INC)
	if [ X$(F90MODTYPE) = X"intel.d" ]; then \
		install -m 644 work.pc $(DEST_INC)/work.pc ;\
	fi

OBJS = eee_mpi_module.o w_base_mpi_module.o w_deriv_mpi_module.o \
	w_integral_mpi_module.o w_mpi_module.o wa_base_mpi_module.o \
	wa_deriv_mpi_module.o wa_integral_mpi_module.o \
	wa_mpi_module.o wt_mpi_module.o 
#wt_galerkin_mpi_module.o

$(TARGET): $(OBJS)
	$(AR) $(ARFLAGS) $@ $(OBJS)
	$(RANLIB) $@

$(OBJS): work.pcl

work.pcl: Makefile ../Config.mk
	sh ../chkpcl.sh $(FFLAGS) $(SYSFFLAGS)

clean:
	-rm -f $(MODS) *.o work.pc* *~ *.bak *.a 

#== Suffixes rules
#
# [JAPANESE] եå롼
#
%.o: %.f90
	$(MPIFC) -c -I../src $(FFLAGS) $(SYSFFLAGS) $(INCLUDES) $<

# dependences

w_deriv_mpi_module.o: w_base_mpi_module.o
w_integral_mpi_module.o: w_base_mpi_module.o
w_mpi_module.o:	w_base_mpi_module.o w_deriv_mpi_module.o w_integral_mpi_module.o
wa_base_mpi_module.o: w_base_mpi_module.o
wa_deriv_mpi_module.o: wa_base_mpi_module.o
wa_integral_mpi_module.o: w_base_mpi_module.o
wa_mpi_module.o: wa_base_mpi_module.o wa_deriv_mpi_module.o wa_integral_mpi_module.o
wt_mpi_module.o: wa_mpi_module.o
#wt_galerkin_mpi_module.o:wt_mpi_module.o

=== src/Makefile ===
# Makefile for spmpdel library

include ../Config.mk

TARGET=lib$(LIBNAME).a

EIGENOBJS=
MATRIXOBJS=

ifeq ($(MATRIXLIB),SSL2)
	EIGENOBJS=ssl2_eigen.o 
	MATRIXOBJS=eigmatrix.o $(EIGENOBJS)
endif
ifeq ($(MATRIXLIB),SSL2TP)
	EIGENOBJS=ssl2tp_eigen.o 
	MATRIXOBJS=eigmatrix.o $(EIGENOBJS)
endif
ifeq ($(MATRIXLIB),LAPACK)
	EIGENOBJS=lapack_eigen.o 
	MATRIXOBJS=eigmatrix.o $(EIGENOBJS)
endif


all: $(TARGET)

install: $(TARGET)
	test -d $(DEST_LIB) || install -d $(DEST_LIB)
	test -d $(DEST_INC) || install -d $(DEST_INC)
	install -m 644 $(TARGET) $(DEST_LIB)
	install -m 644 $(MODS) $(MODINCS) $(DEST_INC)
	if [ X$(F90MODTYPE) = X"intel.d" ]; then \
		install -m 644 work.pc $(DEST_INC)/work.pc ;\
	fi


OBJS =	lumatrix_f77.o lumatrix.o \
	ae_module.o at_module.o au_module.o aq_module.o \
	ee_module.o esc_module.o c2ajcc.o \
	et_module.o eq_module.o eee_module.o \
	w_base_module.o w_integral_module.o \
	w_deriv_module.o w_interpolate_module.o gamma.o dlgamma.o \
	w_spectrum_module.o  w_module.o \
	wa_base_module.o wa_integral_module.o \
	wa_deriv_module.o wa_interpolate_module.o \
	wa_spectrum_module.o wa_module.o wq_module.o \
	wt_module.o wu_module.o wtu_module.o \
	at_ab_galerkin_ND.o at_ad_galerkin_DD.o at_af_galerkin_MM.o     \
	at_ah_galerkin_MMex.o at_ap_galerkin_DN.o at_aq_galerkin_RRSS.o \
	at_av_galerkin_NN.o et_galerkin_module.o \
	l_module.o la_module.o \
	w_zonal_module.o wa_zonal_module.o wt_zonal_module.o \
	wt_galerkin_module.o \
	indexx.o dsort_netlib.o \
	$(MATRIXOBJS)

$(TARGET): $(OBJS)
	$(AR) $(ARFLAGS) $@ $(OBJS)
	$(RANLIB) $@

$(OBJS): work.pcl

work.pcl: Makefile ../Config.mk
	sh ../chkpcl.sh $(FFLAGS) $(SYSFFLAGS)

clean:
	-rm -f $(MODS) *.o work.pc* *~ *.bak *.a eigmatrix.f90

# dependences

at_module.o: lumatrix.o
aq_module.o: lumatrix.o gamma.o

et_module.o: ae_module.o at_module.o lumatrix.o
eq_module.o: ae_module.o aq_module.o lumatrix.o

w_integral_module.o: w_base_module.o
w_deriv_module.o: w_base_module.o
w_spectrum_module.o: w_base_module.o
w_interpolate_module.o: gamma.o w_base_module.o
w_module.o: w_spectrum_module.o w_integral_module.o \
            w_deriv_module.o w_interpolate_module.o w_base_module.o 
wa_spectrum_module.o: w_base_module.o
wa_interpolate_module.o: gamma.o w_base_module.o
wa_base_module.o: w_base_module.o
wa_integral_module.o: w_base_module.o
wa_deriv_module.o: wa_base_module.o w_base_module.o w_deriv_module.o
wa_module.o: wa_base_module.o w_base_module.o \
             wa_integral_module.o w_integral_module.o \
             wa_interpolate_module.o w_interpolate_module.o \
             wa_deriv_module.o w_deriv_module.o \
	     wa_spectrum_module.o w_spectrum_module.o

wt_module.o: wa_module.o at_module.o lumatrix.o
wu_module.o: wa_module.o au_module.o lumatrix.o
wtu_module.o: wt_module.o wu_module.o
wq_module.o: wa_module.o aq_module.o lumatrix.o

at_ab_galerkin_ND.o:at_module.o
at_ad_galerkin_DD.o:at_module.o
at_af_galerkin_MM.o:at_module.o
at_ah_galerkin_MMex.o:at_module.o
at_ap_galerkin_DN.o:at_module.o
at_aq_galerkin_RRSS.o:at_module.o
at_av_galerkin_NN.o:at_module.o
et_galerkin_module.o:et_module.o \
	at_ab_galerkin_ND.o at_ad_galerkin_DD.o at_af_galerkin_MM.o     \
	at_ah_galerkin_MMex.o at_ap_galerkin_DN.o at_aq_galerkin_RRSS.o \
	at_av_galerkin_NN.o
wt_galerkin_module.o:wt_module.o \
	at_ab_galerkin_ND.o at_ad_galerkin_DD.o at_af_galerkin_MM.o     \
	at_ah_galerkin_MMex.o at_ap_galerkin_DN.o at_aq_galerkin_RRSS.o \
	at_av_galerkin_NN.o
wt_zonal_module.o:wa_zonal_module.o at_module.o
wa_zonal_module.o:w_zonal_module.o la_module.o
w_zonal_module.o: l_module.o
la_module.o: l_module.o

eigmatrix.f90: eigmatrix.g90
	$(CPP) -P -D $(MATRIXLIB) $< > $@

eigmatrix.o: $(EIGENOBJS)

ssl2_eigen.o: indexx.o
ssl2tp_eigen.o: indexx.o
lapack_eigen.o: indexx.o

=== test/Makefile ===
# Makefile for spmodel library

include ../Config.mk

SUBDIRS=ae_module at_module au_module aq_module \
	ee_module eee_module eigmatrix esc_module et_module eq_module \
	lumatrix w_module wa_module wt_module wu_module wtu_module wq_module \
	eee_mpi_module w_mpi_module wa_mpi_module wt_mpi_module \
	l_module la_module w_zonal_module wa_zonal_module wt_zonal_module \
	at_galerkin_module misc

NMPIDIRS=eigmatrix ae_module at_module au_module aq_module \
	ee_module eee_module esc_module et_module eq_module \
	w_module wa_module wt_module wu_module wtu_module wq_module \
	l_module la_module w_zonal_module wa_zonal_module wt_zonal_module 

MPIDIRS=eee_mpi_module w_mpi_module wa_mpi_module wt_mpi_module

ifeq (X$(MPIFC),X)
	TESTDIRS=$(NMPIDIRS)
else
	TESTDIRS=$(NMPIDIRS) $(MPIDIRS)
endif

all: clean

test:
	for i in $(TESTDIRS) ; do \
	  cd $$i ; $(MAKE) test ;  \
	  cd ../ ; \
	done

clean: clean.local clean.subdirs

clean.subdirs:
	@for i in $(SUBDIRS) ; do \
	  cd $$i ; $(MAKE) clean ; \
	  cd ../ ; \
	done

clean.local:
	-rm -f $(MODS) *.o work.pc* *~ *.bak *.out *.nc

=== test/aq_module/Makefile ===
# Makefile for spmodel library
#
# $Id: Makefile,v 1.3 2009-01-16 16:23:04 uwabami Exp $
# 


include ../../Config.mk

SPMFRT=$(DEST_BIN)/spmfrt

all: clean

clean:
	-rm -f $(MODS) *.o work.pc* *~ *.bak *.out *.nc *.mod

test:	aq_test_base1d.out aq_test_base2d.out  \
	aq_test_weight.out aq_test_intavr.out  \
	aq_test_boundary_tau_1d.out aq_test_boundary_tau_2d.out \
	aq_test_boundary_grid_1d.out aq_test_boundary_grid_2d.out \
	aq_test1.out aq_test2.out 
	./aq_test_base1d.out
	./aq_test_base2d.out
	./aq_test_weight.out
	./aq_test_intavr.out
	./aq_test_boundary_tau_1d.out
	./aq_test_boundary_tau_2d.out
	./aq_test_boundary_grid_1d.out
	./aq_test_boundary_grid_2d.out
	./aq_test1.out aq_test2.out 

.SUFFIXES: .f90 .out

.f90.out:
	$(FC) -I../../src  $(SYSFFLAGS) -o $@ $< -L../../src -l$(LIBNAME) $(SYSLDFLAGS) $(SYSLDLIBS)

=== test/eee_module/Makefile ===
# Makefile for spmodel library

include ../../Config.mk

SPMFRT=$(DEST_BIN)/spmfrt

all: clean

clean:
	-rm -f $(MODS) *.o work.pc* *~ *.bak *.out *.nc

test:	eee_test_ZetaVorVel.out   eee_test_intavr.out \
	eee_test_ZetaVorVel2.out  eee_test_intavr2.out \
	eee_test_ESpectral.out    eee_test_derivative.out \
	eee_test_ESpectral2.out   eee_test_derivative2.out \
	eee_test_RotVelxVor.out   eee_test_energyhelicity.out \
	eee_test_RotVelxVor2.out  eee_test_energyhelicity2.out \
	eee_test_transform.out    eee_test_transform2.out \
	./eee_test_ZetaVorVel.out
	./eee_test_intavr.out
	./eee_test_ZetaVorVel2.out
	./eee_test_ESpectral.out
	./eee_test_ESpectral2.out
	./eee_test_RotVelxVor.out
	./eee_test_RotVelxVor2.out
	./eee_test_transform.out
	./eee_test_intavr2.out
	./eee_test_derivative.out
	./eee_test_derivative2.out
	./eee_test_energyhelicity.out
	./eee_test_transform2.out
	./eee_test_energyhelicity2.out


.SUFFIXES: .f90 .out

.f90.out:
	$(FC) -I../../src  $(SYSFFLAGS) -o $@ $< -L../../src -l$(LIBNAME) $(SYSLDFLAGS) $(SYSLDLIBS)

=== test/eee_mpi_module/Makefile ===
# Makefile for spmodel library

include ../../Config.mk

SPMFRT=$(DEST_BIN)/spmfrt
#MPIRUN=mpirun -n 2 
MPIRUN=mpiexec -n 2 

clean:
	-rm -f $(MODS) *.o work.pc* *~ *.bak *.out *.nc

test:	eee_mpi_test_gatherZeta.out eee_mpi_test_RotVelxVor.out \
	eee_mpi_test_gathering.out eee_mpi_test_ZetaVorVel.out \
	eee_mpi_test_intavr.out eee_mpi_test_derivative.out \
	eee_mpi_test_transform.out eee_mpi_test_energyhelicity.out
	$(MPIRUN) ./eee_mpi_test_gatherZeta.out	 
	$(MPIRUN) ./eee_mpi_test_RotVelxVor.out	 
	$(MPIRUN) ./eee_mpi_test_gathering.out	 
	$(MPIRUN) ./eee_mpi_test_ZetaVorVel.out	 
	$(MPIRUN) ./eee_mpi_test_intavr.out	 
	$(MPIRUN) ./eee_mpi_test_derivative.out	 
	$(MPIRUN) ./eee_mpi_test_transform.out	 
	$(MPIRUN) ./eee_mpi_test_energyhelicity.out

.SUFFIXES: .f90 .out

.f90.out:
	$(MPIFC) -I../../src -I../../src-mpi $(SYSFFLAGS) -o $@ $< -L../../src -l$(LIBNAME) $(SYSLDFLAGS) $(SYSLDLIBS)

=== test/w_module/Makefile ===
# Makefile for spmodel library

include ../../Config.mk

SPMFRT=$(DEST_BIN)/spmfrt

all: clean

clean:
	-rm -f $(MODS) *.o work.pc* *~ *.bak *.out *.nc

test:	l_nm_test.out nm_l_test.out \
	w_test_base.out w_test_deriv.out w_test_integral.out \
	w_test_interpolate00.out w_test_spectrum.out
	./l_nm_test.out
	./nm_l_test.out
	./w_test_base.out
	./w_test_deriv.out
	./w_test_integral.out
	./w_test_interpolate00.out
	./w_test_spectrum.out

.SUFFIXES: .f90 .out

.f90.out:
	$(FC) -I../../src  $(SYSFFLAGS) -o $@ $< -L../../src -l$(LIBNAME) $(SYSLDFLAGS) $(SYSLDLIBS)

=== test/w_mpi_module/Makefile ===
# Makefile for spmodel library

include ../../Config.mk

SPMFRT=$(DEST_BIN)/spmfrt
MPIRUN=mpirun -np 2 
#MPIRUN=mpiexec -n 2 

all: clean

clean:
	-rm -f $(MODS) *.o work.pc* *~ *.bak *.out *.nc

test:	w_base_mpi_test.out w_deriv_mpi_test.out w_integral_mpi_test.out \
	w_interpolate00_mpi_test.out w_interpolate01_mpi_test.out \
	w_interpolate10_mpi_test.out w_interpolate11_mpi_test.out \
	w_spectrum_mpi_test.out
	$(MPIRUN) w_base_mpi_test.out
	$(MPIRUN) w_deriv_mpi_test.out
	$(MPIRUN) w_integral_mpi_test.out
	$(MPIRUN) w_interpolate00_mpi_test.out
	$(MPIRUN) w_interpolate01_mpi_test.out
	$(MPIRUN) w_interpolate10_mpi_test.out
	$(MPIRUN) w_interpolate11_mpi_test.out
	$(MPIRUN) w_spectrum_mpi_test.out

.SUFFIXES: .f90 .out

.f90.out:
	$(MPIFC) -I../../src -I../../src-mpi $(SYSFFLAGS) -o $@ $< -L../../src -l$(LIBNAME) $(SYSLDFLAGS) $(SYSLDLIBS)

=== test/w_zonal_module/Makefile ===
# Makefile for spmodel library

include ../../Config.mk

SPMFRT=$(DEST_BIN)/spmfrt

all: clean

clean:
	-rm -f $(MODS) *.o work.pc* *~ *.bak *.out *.nc

test:	w_zonal_test_base.out \
	w_zonal_test_deriv.out w_zonal_test_integral.out \
	w_zonal_test_interpolate.out w_zonal_test_spectrum.out
	./w_zonal_test_base.out
	./w_zonal_test_deriv.out
	./w_zonal_test_integral.out
	./w_zonal_test_interpolate.out
	./w_zonal_test_spectrum.out

.SUFFIXES: .f90 .out

.f90.out:
	$(FC) -I../../src  $(SYSFFLAGS) -o $@ $< -L../../src -l$(LIBNAME) $(SYSLDFLAGS) $(SYSLDLIBS)

=== test/wa_module/Makefile ===
# Makefile for spmodel library

include ../../Config.mk

SPMFRT=$(DEST_BIN)/spmfrt

all: clean

clean:
	-rm -f $(MODS) *.o work.pc* *~ *.bak *.out *.nc

test:	wa_test_base.out wa_test_deriv.out wa_test_integral.out \
	wa_test_interpolate00.out wa_test_spectrum.out
	./wa_test_base.out
	./wa_test_deriv.out
	./wa_test_integral.out
	./wa_test_interpolate00.out
	./wa_test_spectrum.out

.SUFFIXES: .f90 .out

.f90.out:
	$(FC) -I../../src  $(SYSFFLAGS) -o $@ $< -L../../src -l$(LIBNAME) $(SYSLDFLAGS) $(SYSLDLIBS)

## spml-g95 0.6.1

=== Makefile ===
# Makefile for spmodel library

include Config.mk

all:
	cd src; $(MAKE)
	cd spmfrt; $(MAKE) $@
	if [ X$(MPIFC) != X ]; then \
		cd src-mpi; $(MAKE) ;\
	fi

install: all
	cd src; $(MAKE) $@
	cd spmfrt; $(MAKE) $@
	if [ X$(MPIFC) != X ]; then \
		cd src-mpi; $(MAKE) $@ ;\
	fi

html:
	cd doc; $(MAKE)
	cd doc; $(MAKE) install

test: check

check:
	cd test ; $(MAKE) test

clean: clean.local
	cd src; $(MAKE) $@
	cd src-mpi; $(MAKE) $@
	cd spmfrt; $(MAKE) $@
	cd demo; $(MAKE) $@
	cd test; $(MAKE) $@
	cd doc; $(MAKE) $@
	cd supplemental; $(MAKE) $@

clean.local:
	-rm *.bak *~

distclean: clean
	-rm -r html
	-rm -f config.status chkfort.cfg chkgmake.cfg
	-rm -f config.cache config.log Config.mk
	@echo ""
	@echo "    Removing Config.mk,"
	@echo "      you should rerun ./configure to build spmodel library."
	@echo ""

cl:
	@cvs2cl --help > /dev/null 2>&1 || \
	    echo -e \
		"\n" \
		"    cvs2cl is not found.\n" \
		"    Please get from http://www.red-bean.com/cvs2cl/\n"
	@cvs2cl --help > /dev/null 2>&1 && \
	    echo -e \
		"This file is generated automatically by\n" \
		"\n" \
		"    cvs2cl.pl -r -b -t --fsf -w --header <This header>\n" \
		"\n" \
		`cvs2cl --version` "\n" \
		"This script is available from "      \
		"http://www.red-bean.com/cvs2cl/\n\n" \
		    | cvs2cl -r -b -t --fsf -w --header -
	rm ChangeLog.bak
	@echo -e "\n" "ChangeLog is Updated." "\n"

=== doc/Makefile ===
--- 
+++ 
@@ -1,6 +1,6 @@
 # Makefile for spmodel library document
 #
-# Version:: $Id: Makefile,v 1.20 2009-02-28 19:55:43 uwabami Exp $
+# Version:: $Id: Makefile,v 1.23 2010-04-06 03:35:23 uwabami Exp $
 #
 # include ../Config.mk
 
@@ -22,7 +22,7 @@
 MAINPAGE=doc/spml_modules.rdoc
 
 PDF=chebyshev.pdf cheb_gal.pdf chebyshev_origin.pdf \
-	w_module.pdf spectral_radial.pdf
+	w_module.pdf w_module_sjpack.pdf spectral_radial.pdf
 HTML=INSTALL.html INSTALL.html.ja
 
 all: $(PDF) html
@@ -39,10 +39,11 @@
 
 clean:
 	-rm -f *.pdf
+	-rm -rf INSTALL.html INSTALL.html.ja
 
 clean.all: clean
 	-make -f Makefile.rd2html clean
-	-rm -rf $(HTMLDIR) INSTALL.html INSTALL.html.ja
+	-rm -rf $(HTMLDIR)/
 
 distclean: clean.all
 .SUFFIXES: .tex .pdf

=== src-mpi/Makefile ===
--- 
+++ 
@@ -7,10 +7,10 @@
 all: $(TARGET)
 
 install: $(TARGET)
-	test -d $(DEST_INC) || install -d $(DEST_INC)
-	install -m 644 $(MODS) $(MODINCS) $(DEST_INC)
+	test -d $(DEST_INC) || $(INSTALLDIR) $(DEST_INC)
+	$(INSTALL) $(MODS) $(MODINCS) $(DEST_INC)
 	if [ X$(F90MODTYPE) = X"intel.d" ]; then \
-		install -m 644 work.pc $(DEST_INC)/work.pc ;\
+		$(INSTALL) work.pc $(DEST_INC)/work.pc ;\
 	fi
 
 OBJS = eee_mpi_module.o w_base_mpi_module.o w_deriv_mpi_module.o \

=== src/Makefile ===
# Makefile for spmpdel library

include ../Config.mk

TARGET=lib$(LIBNAME).a

EIGENOBJS=
EIGMATRIXOBJS=
LUMATRIXOBJS=lumatrix_f77_vec.o lumatrix.o

ifeq ($(EIGMATRIXLIB),SSL2)
	EIGENOBJS=ssl2_eigen.o 
	EIGMATRIXOBJS=eigmatrix.o $(EIGENOBJS)
endif
ifeq ($(EIGMATRIXLIB),SSL2TP)
	EIGENOBJS=ssl2tp_eigen.o 
	EIGMATRIXOBJS=eigmatrix.o $(EIGENOBJS)
endif
ifeq ($(EIGMATRIXLIB),LAPACK)
	EIGENOBJS=lapack_eigen.o 
	EIGMATRIXOBJS=eigmatrix.o $(EIGENOBJS)
endif

ifeq ($(LUMATRIXLIB),VEC)
	LUMATRIXOBJS=lumatrix_f77_vec.o lumatrix.o
endif
ifeq ($(LUMATRIXLIB),OMP)
	LUMATRIXOBJS=lumatrix_f77_omp.o lumatrix.o
endif
ifeq ($(LUMATRIXLIB),SSL2)
	LUMATRIXOBJS=lumatrix_ssl2.o
endif
ifeq ($(LUMATRIXLIB),SSL2TP)
	LUMATRIXOBJS=lumatrix_ssl2tp.o
endif
ifeq ($(LUMATRIXLIB),LAPACK)
	LUMATRIXOBJS=lumatrix_lapack.o
endif

all: $(TARGET)

install: $(TARGET)
	test -d $(DEST_LIB) || $(INSTALLDIR) $(DEST_LIB)
	test -d $(DEST_INC) || $(INSTALLDIR) $(DEST_INC)
	$(INSTALL) $(TARGET) $(DEST_LIB)
	$(INSTALL) $(MODS) $(MODINCS) $(DEST_INC)
	if [ X$(F90MODTYPE) = X"intel.d" ]; then \
		$(INSTALL) work.pc $(DEST_INC)/work.pc ;\
	fi


OBJS =	$(LUMATRIXOBJS) \
	ae_module.o at_module.o au_module.o aq_module.o \
	ee_module.o esc_module.o c2ajcc.o ef_module.o \
	et_module.o eq_module.o eee_module.o tee_module.o \
	ae_module_fftj.o ee_module_fftj.o et_module_fftj.o \
	w_base_module.o w_integral_module.o \
	w_deriv_module.o w_interpolate_module.o gamma.o dlgamma.o \
	w_spectrum_module.o  w_module.o \
	wa_base_module.o wa_integral_module.o \
	wa_deriv_module.o wa_interpolate_module.o \
	wa_spectrum_module.o wa_module.o wq_module.o \
	wt_module.o wu_module.o wtu_module.o wtq_module.o \
	w_base_module_sjpack.o w_integral_module_sjpack.o \
	w_deriv_module_sjpack.o w_interpolate_module_sjpack.o \
	w_spectrum_module_sjpack.o  w_module_sjpack.o \
	wa_base_module_sjpack.o wa_deriv_module_sjpack.o \
	wa_integral_module_sjpack.o wa_spectrum_module_sjpack.o \
	wa_interpolate_module_sjpack.o wa_module_sjpack.o \
	wt_module_sjpack.o wq_module_sjpack.o wtq_module_sjpack.o \
	at_ab_galerkin_ND.o at_ad_galerkin_DD.o at_af_galerkin_MM.o     \
	at_ah_galerkin_MMex.o at_ap_galerkin_DN.o at_aq_galerkin_RRFF.o \
	at_av_galerkin_NN.o et_galerkin_module.o et_galerkin_module_fftj.o \
	l_module.o la_module.o \
	w_zonal_module.o wa_zonal_module.o wt_zonal_module.o \
	l_module_sjpack.o la_module_sjpack.o \
	w_zonal_module_sjpack.o wa_zonal_module_sjpack.o \
	wt_zonal_module_sjpack.o \
	wt_galerkin_module.o wt_galerkin_module_sjpack.o \
	wt_zonal_galerkin_module.o wt_zonal_galerkin_module_sjpack.o \
	indexx.o dsort_netlib.o \
	$(EIGMATRIXOBJS)

$(TARGET): $(OBJS)
	$(AR) $(ARFLAGS) $@ $(OBJS)
	$(RANLIB) $@

$(OBJS): work.pcl

work.pcl: Makefile ../Config.mk
	sh ../chkpcl.sh $(FFLAGS) $(SYSFFLAGS)

clean:
	-rm -f $(MODS) *.o work.pc* *~ *.bak *.a eigmatrix.f90

# dependences

at_module.o: $(LUMATRIXOBJS)
aq_module.o: $(LUMATRIXOBJS) gamma.o

et_module.o: ae_module.o at_module.o $(LUMATRIXOBJS)
eq_module.o: ae_module.o aq_module.o $(LUMATRIXOBJS)

w_integral_module.o: w_base_module.o
w_deriv_module.o: w_base_module.o
w_spectrum_module.o: w_base_module.o
w_interpolate_module.o: gamma.o w_base_module.o
w_module.o: w_spectrum_module.o w_integral_module.o \
	    w_deriv_module.o w_interpolate_module.o w_base_module.o 

wa_spectrum_module.o: w_base_module.o
wa_interpolate_module.o: gamma.o w_base_module.o
wa_base_module.o: w_base_module.o
wa_integral_module.o: w_base_module.o
wa_deriv_module.o: wa_base_module.o w_base_module.o w_deriv_module.o
wa_module.o: wa_base_module.o w_base_module.o \
	     wa_integral_module.o w_integral_module.o \
	     wa_interpolate_module.o w_interpolate_module.o \
	     wa_deriv_module.o w_deriv_module.o \
	     wa_spectrum_module.o w_spectrum_module.o

wt_module.o: wa_module.o at_module.o $(LUMATRIXOBJS)
wu_module.o: wa_module.o au_module.o $(LUMATRIXOBJS)
wtu_module.o: wt_module.o wu_module.o
wq_module.o: wa_module.o aq_module.o $(LUMATRIXOBJS)
wtq_module.o: wt_module.o wq_module.o

w_integral_module_sjpack.o: w_base_module_sjpack.o
w_deriv_module_sjpack.o: w_base_module_sjpack.o
w_spectrum_module_sjpack.o: w_base_module_sjpack.o
w_interpolate_module_sjpack.o: gamma.o w_base_module_sjpack.o
w_module_sjpack.o: w_spectrum_module_sjpack.o w_integral_module_sjpack.o \
	w_deriv_module_sjpack.o w_interpolate_module_sjpack.o w_base_module_sjpack.o

wa_spectrum_module_sjpack.o: w_base_module_sjpack.o
wa_interpolate_module_sjpak.o: gamma.o w_basae_module_sjpack.o
wa_base_module_sjpack.o: w_base_module_sjpack.o
wa_integral_module_sjpack.o: w_base_module_sjpack.o
wa_deriv_module_sjpack.o: wa_base_module_sjpack.o w_base_module_sjpack.o w_deriv_module_sjpack.o
wa_module_sjpack.o: wa_base_module_sjpack.o w_base_module_sjpack.o \
	wa_integral_module_sjpack.o w_integral_module_sjpack.o \
	wa_interpolate_module_sjpack.o w_interpolate_module_sjpack.o \
	wa_deriv_module_sjpack.o w_deriv_module_sjpack.o \
	wa_spectrum_module_sjpack.o w_spectrum_module_sjpack.o

wt_module_sjpack.o: wa_module_sjpack.o at_module.o $(LUMATRIXOBJS)
wq_module_sjpack.o: wa_module_sjpack.o aq_module.o $(LUMATRIXOBJS)
wtq_module_sjpack.o: wa_module_sjpack.o wq_module_sjpack.o

at_ab_galerkin_ND.o:at_module.o
at_ad_galerkin_DD.o:at_module.o
at_af_galerkin_MM.o:at_module.o
at_ah_galerkin_MMex.o:at_module.o
at_ap_galerkin_DN.o:at_module.o
at_aq_galerkin_RRFF.o:at_module.o
at_av_galerkin_NN.o:at_module.o
et_galerkin_module.o:et_module.o \
	at_ab_galerkin_ND.o at_ad_galerkin_DD.o at_af_galerkin_MM.o  \
	at_ah_galerkin_MMex.o at_ap_galerkin_DN.o at_aq_galerkin_RRFF.o \
	at_av_galerkin_NN.o
et_galerkin_module_fftj.o:et_module_fftj.o \
	at_ab_galerkin_ND.o at_ad_galerkin_DD.o at_af_galerkin_MM.o  \
	at_ah_galerkin_MMex.o at_ap_galerkin_DN.o at_aq_galerkin_RRFF.o \
	at_av_galerkin_NN.o
wt_galerkin_module.o:wt_module.o \
	at_ab_galerkin_ND.o at_ad_galerkin_DD.o at_af_galerkin_MM.o \
	at_ah_galerkin_MMex.o at_ap_galerkin_DN.o at_aq_galerkin_RRFF.o \
	at_av_galerkin_NN.o
wt_galerkin_module_sjpack.o:wt_module_sjpack.o \
	at_ab_galerkin_ND.o at_ad_galerkin_DD.o at_af_galerkin_MM.o \
	at_ah_galerkin_MMex.o at_ap_galerkin_DN.o at_aq_galerkin_RRFF.o \
	at_av_galerkin_NN.o
wt_zonal_module.o:wa_zonal_module.o at_module.o
wt_zonal_module_sjpack.o:wa_zonal_module_sjpack.o at_module.o
wt_zonal_galerkin_module.o:wt_zonal_module.o \
	at_ab_galerkin_ND.o at_ad_galerkin_DD.o at_af_galerkin_MM.o \
	at_ah_galerkin_MMex.o at_ap_galerkin_DN.o at_aq_galerkin_RRFF.o \
	at_av_galerkin_NN.o
wt_zonal_galerkin_module_sjpack.o:wt_zonal_module_sjpack.o \
	at_ab_galerkin_ND.o at_ad_galerkin_DD.o at_af_galerkin_MM.o \
	at_ah_galerkin_MMex.o at_ap_galerkin_DN.o at_aq_galerkin_RRFF.o \
	at_av_galerkin_NN.o
wa_zonal_module.o:w_zonal_module.o la_module.o
w_zonal_module.o: l_module.o
la_module.o: l_module.o

eigmatrix.f90: eigmatrix.g90
	$(CPP) -P -D $(EIGMATRIXLIB) $< > $@

eigmatrix.o: $(EIGENOBJS)

ssl2_eigen.o: indexx.o
ssl2tp_eigen.o: indexx.o
lapack_eigen.o: indexx.o

=== test/Makefile ===
# Makefile for spmodel library

include ../Config.mk

MISCDIRS=at_galerkin_module misc

NMPIDIRS=eigmatrix lumatrix ae_module at_module au_module aq_module \
	ee_module esc_module et_module eq_module ef_module \
	eee_module tee_module \
	w_module wa_module wt_module \
	wu_module wtu_module wq_module wtq_module \
	l_module la_module w_zonal_module wa_zonal_module wt_zonal_module \
	ae_module_fftj ee_module_fftj et_module_fftj \
	w_module_sjpack wa_module_sjpack wt_module_sjpack wq_module_sjpack \
	wtq_module_sjpack \
	l_module_sjpack la_module_sjpack \
	w_zonal_module_sjpack wa_zonal_module_sjpack # wt_zonal_module_sjpack

MPIDIRS=eee_mpi_module w_mpi_module wa_mpi_module wt_mpi_module

ifeq (X$(EIGMATRIXLIB),X)
	TESTDIRS:=$(NMPIDIRS)
else
	TESTDIRS:=$(NMPIDIRS) eigmatrix
endif

ifeq (X$(MPIFC),X)
	SUBDIRS:=$(TESTDIRS) $(MISCDIRS)
else
	TESTDIRS:=$(TESTDIRS) $(MPIDIRS)
	SUBDIRS:=$(NMPIDIRS) $(MPIDIRS) $(MISCDIRS)
endif

all: clean

test:
	for i in $(TESTDIRS) ; do \
	  cd $$i || exit 1 ; \
	  $(MAKE) test || exit 1 ;  \
	  cd ../ ; \
	done
	@echo ""
	@echo ""
	@echo " *** Compilation and installation are succeeded !! *** "
	@echo ""
	@echo ""

clean: clean.local clean.subdirs

clean.subdirs:
	@for i in $(SUBDIRS) ; do \
	  cd $$i ; $(MAKE) clean ; \
	  cd ../ ; \
	done

clean.local:
	-rm -f $(MODS) *.o work.pc* *~ *.bak *.out *.nc

=== test/ae_module/Makefile ===
# Makefile for spmodel library
#
# $Id: Makefile,v 1.5 2009-01-16 16:23:04 uwabami Exp $
# 

include ../../Config.mk

SPMFRT=$(DEST_BIN)/spmfrt

all: clean

clean:
	-rm -f $(MODS) *.o work.pc* *~ *.bak *.out *.nc

test:	ae_test_base1d.out ae_test_base2d.out ae_test_intavr.out 
	./ae_test_base1d.out
	./ae_test_base2d.out
	./ae_test_intavr.out

.SUFFIXES: .f90 .out

.f90.out:
	$(FC) -I../../src  $(SYSFFLAGS) -o $@ $< -L../../src -l$(LIBNAME) $(SYSLDFLAGS) $(SYSLDLIBS)

=== test/ae_module_fftj/Makefile ===
# Makefile for spmodel library
#
# $Id: Makefile,v 1.1 2009-09-11 07:32:51 takepiro Exp $
# 

include ../../Config.mk

SPMFRT=$(DEST_BIN)/spmfrt

all: clean

clean:
	-rm -f $(MODS) *.o work.pc* *~ *.bak *.out *.nc

test:	ae_module_fftj_base1d_test.out \
	ae_module_fftj_base2d_test.out \
	ae_module_fftj_integral_test.out
	./ae_module_fftj_base1d_test.out
	./ae_module_fftj_base2d_test.out
	./ae_module_fftj_integral_test.out

.SUFFIXES: .f90 .out

.f90.out:
	$(FC) -I../../src  $(SYSFFLAGS) -o $@ $< -L../../src -l$(LIBNAME) $(SYSLDFLAGS) $(SYSLDLIBS)

=== test/aq_module/Makefile ===
--- 
+++ 
@@ -1,6 +1,6 @@
 # Makefile for spmodel library
 #
-# $Id: Makefile,v 1.3 2009-01-16 16:23:04 uwabami Exp $
+# $Id: Makefile,v 1.4 2009-07-24 09:19:53 uwabami Exp $
 # 
 
 
@@ -16,8 +16,7 @@
 test:	aq_test_base1d.out aq_test_base2d.out  \
 	aq_test_weight.out aq_test_intavr.out  \
 	aq_test_boundary_tau_1d.out aq_test_boundary_tau_2d.out \
-	aq_test_boundary_grid_1d.out aq_test_boundary_grid_2d.out \
-	aq_test1.out aq_test2.out 
+	aq_test_boundary_grid_1d.out aq_test_boundary_grid_2d.out 
 	./aq_test_base1d.out
 	./aq_test_base2d.out
 	./aq_test_weight.out
@@ -26,7 +25,6 @@
 	./aq_test_boundary_tau_2d.out
 	./aq_test_boundary_grid_1d.out
 	./aq_test_boundary_grid_2d.out
-	./aq_test1.out aq_test2.out 
 
 .SUFFIXES: .f90 .out

=== test/at_module/Makefile ===
# Makefile for spmodel library

include ../../Config.mk

SPMFRT=$(DEST_BIN)/spmfrt

all: clean

clean:
	-rm -f $(MODS) *.o work.pc* *~ *.bak *.out *.nc

test:	at_test_base1d.out at_test_base2d.out at_test_base.out \
	at_test_intavr.out at_test_interpolate.out at_test_weight.out \
	at_test_boundaries1d.out at_test_boundaries2d.out
	./at_test_base1d.out
	./at_test_base2d.out
	./at_test_base.out
	./at_test_intavr.out
	./at_test_interpolate.out
	./at_test_weight.out
	./at_test_boundaries1d.out
	./at_test_boundaries2d.out

.SUFFIXES: .f90 .out

.f90.out:
	$(FC) -I../../src  $(SYSFFLAGS) -o $@ $< -L../../src -l$(LIBNAME) $(SYSLDFLAGS) $(SYSLDLIBS)

=== test/au_module/Makefile ===
# Makefile for spmodel library

include ../../Config.mk

SPMFRT=$(DEST_BIN)/spmfrt

all: clean

clean:
	-rm -f $(MODS) *.o work.pc* *~ *.bak *.out *.nc

test:	au_test_base1d.out au_test_base2d.out \
	au_test_intavr.out au_test_weight.out \
	au_test_boundary_grid_1d.out au_test_boundary_grid_2d.out \
	au_test_boundary_tau_1d.out au_test_boundary_tau_2d.out
	./au_test_base1d.out
	./au_test_base2d.out
	./au_test_intavr.out
	./au_test_weight.out
	./au_test_boundary_tau_1d.out
	./au_test_boundary_tau_2d.out
	./au_test_boundary_tau_1d.out
	./au_test_boundary_tau_2d.out

.SUFFIXES: .f90 .out

.f90.out:
	$(FC) -I../../src  $(SYSFFLAGS) -o $@ $< -L../../src -l$(LIBNAME) $(SYSLDFLAGS) $(SYSLDLIBS)

=== test/ee_module/Makefile ===
# Makefile for spmodel library

include ../../Config.mk

SPMFRT=$(DEST_BIN)/spmfrt

all: clean

clean:
	-rm -f $(MODS) *.o work.pc* *~ *.bak *.out *.nc

test:	ee_test_transform.out ee_test_derivative.out \
	ee_test_jacobian.out ee_test_jacobianZ.out \
	ee_test_intavr.out ee_test_spectrum.out \
	ee_test_transform2.out ee_test_derivative2.out \
	ee_test_jacobian2.out ee_test_jacobianZ2.out \
	ee_test_intavr2.out ee_test_spectrum2.out \
	ee_test_interpolate.out
	./ee_test_transform.out 
	./ee_test_derivative.out 
	./ee_test_jacobian.out
	./ee_test_jacobianZ.out
	./ee_test_intavr.out
	./ee_test_spectrum.out
	./ee_test_transform2.out 
	./ee_test_derivative2.out 
	./ee_test_jacobian2.out
	./ee_test_jacobianZ2.out
	./ee_test_intavr2.out
	./ee_test_spectrum2.out
	./ee_test_interpolate.out

.SUFFIXES: .f90 .out

.f90.out:
	$(FC) -I../../src  $(SYSFFLAGS) -o $@ $< -L../../src -l$(LIBNAME) $(SYSLDFLAGS) $(SYSLDLIBS)

=== test/ee_module_fftj/Makefile ===
# Makefile for spmodel library

include ../../Config.mk

SPMFRT=$(DEST_BIN)/spmfrt

all: clean

clean:
	-rm -f $(MODS) *.o work.pc* *~ *.bak *.out *.nc

test:	ee_module_fftj_base_test1.out \
	ee_module_fftj_base_test2.out \
	ee_module_fftj_deriv_test1.out \
	ee_module_fftj_deriv_test2.out \
	ee_module_fftj_jacobian_test1.out \
	ee_module_fftj_jacobian_test2.out \
	ee_module_fftj_jacobianZ_test1.out \
	ee_module_fftj_jacobianZ_test2.out \
	ee_module_fftj_integral_test1.out \
	ee_module_fftj_integral_test2.out \
	ee_module_fftj_spectrum_test1.out \
	ee_module_fftj_spectrum_test2.out \
	ee_module_fftj_interpolate_test.out
	./ee_module_fftj_base_test1.out 
	./ee_module_fftj_base_test2.out 
	./ee_module_fftj_deriv_test1.out
	./ee_module_fftj_deriv_test2.out 
	./ee_module_fftj_jacobian_test1.out
	./ee_module_fftj_jacobian_test2.out
	./ee_module_fftj_jacobianZ_test1.out
	./ee_module_fftj_jacobianZ_test2.out
	./ee_module_fftj_integral_test1.out
	./ee_module_fftj_integral_test2.out
	./ee_module_fftj_spectrum_test1.out
	./ee_module_fftj_spectrum_test2.out
	./ee_module_fftj_interpolate_test.out

.SUFFIXES: .f90 .out

.f90.out:
	$(FC) -I../../src  $(SYSFFLAGS) -o $@ $< -L../../src -l$(LIBNAME) $(SYSLDFLAGS) $(SYSLDLIBS)

=== debian/changelog ===
spml-g95 (0.6.1-1) unstable; urgency=low

  * Imported Upstream version 0.6.1
  * Using tarball.mk for serial/parallel build

 -- Youhei SASAKI <uwabami@gfd-dennou.org>  Wed, 26 Jan 2011 10:28:59 +0900

spml-g95 (0.5.0cvs20090926-3) unstable; urgency=low

  * missing dependencies: lapack-g95 

 -- Youhei SASAKI <uwabami@gfd-dennou.org>  Tue, 13 Oct 2009 17:56:18 +0900

spml-g95 (0.5.0cvs20090926-2) unstable; urgency=low

  * replace lumatrix_f77.f
    - lumatrix_f77_vec.f is default now!

 -- Youhei SASAKI <uwabami@gfd-dennou.org>  Mon, 12 Oct 2009 07:26:52 +0900

spml-g95 (0.5.0cvs20090926-1) unstable; urgency=low

  * Imported Upstream version 0.5.0cvs20090926
  * remove threadprivate directive
    - This directive work very few environment... sigh.
    - see debian/patches/RemoveThreadPrivate

 -- Youhei SASAKI <uwabami@gfd-dennou.org>  Fri, 02 Oct 2009 10:55:57 +0900

=== debian/control ===
Source: spml-g95
Section: science
Priority: optional
Maintainer: Youhei SASAKI <uwabami@gfd-dennou.org>
Build-Depends: cdbs, debhelper (>= 5), autotools-dev, openmpi-g95, libnetcdff-g95-dev, gtool5-g95, libispack-g95-dev, liblapack-g95-dev, rdtool, quilt
Standards-Version: 3.8.3
Homepage: http://www.gfd-dennou.org/arch/spmodel

Package: spml-g95
Architecture: any
Conflicts: spml-lapack-g95 (<< 0.5.0-5)
Replaces: spml-lapack-g95 (<< 0.5.0-1)
Provides: spml-g95
Depends: ${shlibs:Depends}, ${misc:Depends}, netcdf-g95, gtool5-g95, ispack-g95, openmpi-g95, liblapack-g95-dev
Description: Fortran90 module library for solveing fundamental GFD problems
 SPML (a SPectral Model Library) is a Fortran90 module library for
 constructing spectral models for fundamental geophysical fluid
 dynamic problems. Fortran90 modules of this library are based on
 ISPACK (http://www.gfd-dennou.org/arch/ispack), which is also library
 for spectral models but written in Fortran77. This package provides
 module binary files built with G95 Fortran Compiler.
 .

Package: spml-lapack-g95
Architecture: all
Depends: spml-g95
Description: Transitional package
 This dummy package is provided for a smooth transition from the
 previous spml-lapack-g95 package (the package is replaced by spml-g95).
 It may safely be removed after installation.

=== debian/rules ===
#!/usr/bin/make -f

DEB_TAR_SRCDIR = spml-0.6.1
DEB_TARBALL = $(CURDIR)/upstream/$(DEB_TAR_SRCDIR).tar.gz
SRC_TREE = $(CURDIR)/build-tree/$(DEB_TAR_SRCDIR)

include /usr/share/cdbs/1/rules/tarball.mk
include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/langcore.mk
include /usr/share/cdbs/1/rules/patchsys-quilt.mk

EXT             := -g95
PACKAGE         := spml$(EXT)
FC              := /usr/bin/g95
MPIFC           := /usr/bin/mpif90.openmpi-g95
SYSFFLAGS       := -O3 -fPIC
FFLAGS          := -O3 -fPIC

CONFIGURE_ENV :=				\
	FC="$(FC)"					\
	SYSFFLAGS="$(SYSFFLAGS)"	\
	FFLAGS="$(FFLAGS)"
CONFIGURE_ENV_MPI:=				\
	FC="$(MPIFC)"				\
	SYSFFLAGS="$(SYSFFLAGS)"	\
	FFLAGS="$(FFLAGS)"

# NetCDF
NETCDF    :=/usr/lib/libnetcdf.a
NETCDFF   :=/usr/lib/libnetcdff$(EXT).a
NETCDFINC :=/usr/include/netcdf$(EXT)/netcdf.inc
CONF_NETCDF:=					\
	--with-netcdf=$(NETCDF)		\
	--with-netcdff=$(NETCDFF)	\
	--with-netcdf-include=$(NETCDFINC)

# Gtool
GTOOL5          :=/usr/lib/gtool5$(EXT)/lib/libgtool5.a
GTOOL5_MPI      :=/usr/lib/gtool5$(EXT)-mpi/lib/libgtool5-mpi.a
CONF_GTOOL5     :=--with-gtool5=$(GTOOL5)
CONF_GTOOL5_MPI :=--with-gtool5=$(GTOOL5_MPI)

# ISPACK
ISPACK      := /usr/lib/libispack$(EXT).a
CONF_ISPACK :=--with-ispack=$(ISPACK)

# Lapack
CONF_LUMATRIX:=--with-lapack=/usr/lib/liblapack-g95.a

CONF_FLAGS :=			  \
	$(CONF_NETCDF)		\
	$(CONF_GTOOL5)		\
	$(CONF_ISPACK)		\
	$(CONF_LUMATRIX)  \
	--with-lumatrix=OMP

CONF_FLAGS_MPI :=		\
	$(CONF_NETCDF)		\
	$(CONF_GTOOL5_MPI)	\
	$(CONF_ISPACK)		\
	$(CONF_LUMATRIX)	\
	--with-lumatrix=OMP \
	--with-mpifc=$(MPIFC)

MANPAGES :=debian/*.1
DEB_INSTALL_MANPAGES_$(PACKAGE):=$(MANPAGES)

clean::
	-quilt pop -a && rm -rf .pc
	-[ -f Config.mk ] && $(MAKE) distclean
	rm -f debian/*.postinst; \
	rm -f debian/*.prerm  ; \
	rm -f debian/*.docs ;\
	rm -f debian/*.links ;\
	rm -f $(MANPAGES)
	rm -f $(CURDIR)/upstream/*.cdbs-config_list

pre-build::
	(cd ./debian && \
	PACKAGE=$(PACKAGE) EXT=$(EXT) PRIORITY=90 sh ./pre-build.sh)

configure/$(PACKAGE):: pre-configure configure-serial configure-parallel
pre-configure: pre-configure-stamp
pre-configure-stamp:
	cp -r $(SRC_TREE) $(SRC_TREE)-parallel
	touch $@
configure-serial:: configure-serial-stamp
configure-serial-stamp:
	(cd $(SRC_TREE) && \
	  $(CONFIGURE_ENV) ./configure $(CONF_FLAGS) \
	  --prefix=/usr/lib/$(PACKAGE) )
	touch $@
configure-parallel: configure-parallel-stamp
configure-parallel-stamp:
	(cd $(SRC_TREE)-parallel && \
	  $(CONFIGURE_ENV_MPI) ./configure $(CONF_FLAGS_MPI) \
	  --prefix=/usr/lib/$(PACKAGE)-mpi )
	touch $@

build/$(PACKAGE):: build-serial build-parallel
build-serial: build-serial-stamp
build-serial-stamp:
	( cd $(SRC_TREE) && make LIBNAME=$(PACKAGE) )
	touch $@
build-parallel: build-parallel-stamp
build-parallel-stamp:
	( cd $(SRC_TREE)-parallel && make LIBNAME=$(PACKAGE) )
	touch $@

install/$(PACKAGE):: install-serial install-parallel post-install
install-serial: install-serial-stamp
install-serial-stamp:
	( cd $(SRC_TREE) && \
	  make install DESTDIR=$(CURDIR)/debian/$(PACKAGE) LIBNAME=$(PACKAGE) )
	touch $@
install-parallel: install-parallel-stamp
install-parallel-stamp:
	( cd $(SRC_TREE)-parallel && \
	  make install DESTDIR=$(CURDIR)/debian/$(PACKAGE) LIBNAME=$(PACKAGE) )
	touch $@
post-install: post-install-stamp
post-install-stamp:
	cd $(CURDIR)/debian/$(PACKAGE)/usr/lib/$(PACKAGE)-mpi/bin ; rm spmfrt
	mkdir -p $(CURDIR)/debian/$(PACKAGE)/usr/share/man/man1
	@for f in spmfrt spmconfig ; do \
	  cat debian/$(PACKAGE)/usr/lib/$(PACKAGE)/bin/$$f | \
	      sed -e s/^#//g | rd2 -r rd/rd2man-lib > debian/$$f$(EXT).1 ;\
	done
	cat debian/$(PACKAGE)/usr/lib/$(PACKAGE)-mpi/bin/mpispmfrt | \
	    sed -e s/^#//g | rd2 -r rd/rd2man-lib > debian/mpispmfrt$(EXT).1
	cat debian/$(PACKAGE)/usr/lib/$(PACKAGE)-mpi/bin/spmconfig | \
	    sed -e s/^#//g | rd2 -r rd/rd2man-lib > debian/mpispmconfig$(EXT).1
